import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import "antd/es/dropdown/style";
import _Dropdown from "antd/es/dropdown";
import "antd/es/config-provider/style";
import _ConfigProvider from "antd/es/config-provider";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useContext } from 'react';
import Footer from '../DropdownFooter';
import './index.less';

var FilterDropdown = function FilterDropdown(props) {
  var children = props.children,
      label = props.label,
      footer = props.footer,
      disabled = props.disabled,
      onVisibleChange = props.onVisibleChange,
      visible = props.visible,
      footerRender = props.footerRender,
      placement = props.placement;

  var _useContext = useContext(_ConfigProvider.ConfigContext),
      getPrefixCls = _useContext.getPrefixCls;

  var prefixCls = getPrefixCls('pro-core-field-dropdown');
  return _jsx(_Dropdown, {
    disabled: disabled,
    placement: placement,
    trigger: ['click'],
    visible: visible,
    onVisibleChange: onVisibleChange,
    overlay: _jsxs("div", {
      className: "".concat(prefixCls, "-overlay"),
      children: [_jsx("div", {
        className: "".concat(prefixCls, "-content"),
        children: children
      }), footer && _jsx(Footer, _objectSpread({
        disabled: disabled,
        footerRender: footerRender
      }, footer))]
    }),
    children: _jsx("span", {
      className: "".concat(prefixCls, "-label"),
      children: label
    })
  });
};

export default FilterDropdown;